# A simple SVM / Logistic regression based predictor

import scipy.sparse
import numpy
import os
from scipy.sparse import lil_matrix, coo_matrix
from scipy.io import loadmat, savemat
from scipy.io import mmread, mmwrite

from sklearn.svm.sparse import LinearSVC
from sklearn.linear_model.sparse import LogisticRegression

import numpy

if __name__ == '__main__':
    predictPath = "predictions"
    if not os.path.isdir(predictPath):
        os.mkdir(predictPath)
    
    preprocessed = "preprocessed"
    uactFile = os.path.join(preprocessed, "uact") # Semantic transcriptions
    semiFile = os.path.join(preprocessed, "semi") # Top semantic hypothesis
    tranFile = os.path.join(preprocessed, "transcription") # Orthographic transcriptions
    asrFile  = os.path.join(preprocessed, "asr") # Top ASR hypothesis
    
    X = loadmat(asrFile + '-train.mat')['X']
    Y = loadmat(uactFile + '-train.items.mat')['Y']
    Z = numpy.transpose(loadmat(uactFile + '-train.types.mat')['Z'][0])

    XNew = loadmat(asrFile + '-test.mat')['X']
    
    # First fit a model for the type    
    svc = LinearSVC(C=2,fit_intercept=False)

    
    svc.fit(X, Z)
    ZNew = numpy.matrix(svc.predict(XNew))
    mmwrite(os.path.join(predictPath, "linear.types.mtx"), ZNew)
    
    # Now fit a model for each item
    YNew = lil_matrix((XNew.shape[0], Y.shape[1]))
    for i in range(0, Y.shape[1]):
        print "Predicting for item " + str(i)
        yVec = Y[:,i].toarray().flatten()
        svc = LogisticRegression()
    
        svc.fit (X, yVec)
        yVecNew = svc.predict(XNew)
        A = coo_matrix(yVecNew)
        for j,k,v in zip(A.row, A.col, A.data):
            YNew[k,i] = v
    
    mmwrite(os.path.join(predictPath, "linear.items.mtx"), YNew)
    
    #savemat(os.path.join(predictPath, "type-prediction.mat"), {'Z', ZNew})
    
